//---------------------------------------------------------------------------------
//
// Autogenerated from CreateDllWrapper.pl
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
// All Rights Reserved.
//
//---------------------------------------------------------------------------------

#ifndef TA_DYNAMICOBJECT_WRAPPER_H
#define TA_DYNAMICOBJECT_WRAPPER_H

#include "../Common/Types.h"

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

enum
{
	TA_DYNAMICOBJECT_REINIT_FLAG_UPDATE_MASS = 0x1,
	TA_DYNAMICOBJECT_REINIT_FLAG_UPDATE_INERTIA_TENSOR = 0x2,
	TA_DYNAMICOBJECT_REINIT_FLAG_UPDATE_CENTER_OFFSET = 0x4,
};

TA_EXPORT void TA_CALL TaDynamicObject_InitialiseFromFile(
	TaDynamicObject* pTaDynamicObject,
	const TaChar* szFileName);

TA_EXPORT void TA_CALL TaDynamicObject_InitialiseAsABox(
	TaDynamicObject* pTaDynamicObject,
	const TaAABB* aabb);

TA_EXPORT void TA_CALL TaDynamicObject_InitialiseAsAnOrientedBox(
	TaDynamicObject* pTaDynamicObject,
	const TaAABB* aabb,
	const TaMFrame* mFrame);

TA_EXPORT void TA_CALL TaDynamicObject_InitialiseAsACapsule(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Start,
	const TaVec3* v3End,
	float fRadius);

TA_EXPORT void TA_CALL TaDynamicObject_InitialiseAsASphere(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Center,
	float fRadius);

TA_EXPORT void TA_CALL TaDynamicObject_InitialiseAsACylinder(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Start,
	const TaVec3* v3End,
	float fRadius);

TA_EXPORT void TA_CALL TaDynamicObject_Initialise(
	TaDynamicObject* pTaDynamicObject,
	TaCollisionObjectCombo* pCollisionObjectCombo);

TA_EXPORT void TA_CALL TaDynamicObject_Initialise2(
	TaDynamicObject* pTaDynamicObject,
	TaCollisionObjectComplex* pCollisionObjectComplex);

TA_EXPORT void TA_CALL TaDynamicObject_Finalise(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaMFrame* TA_CALL TaDynamicObject_GetFrame(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetFrame(
	TaDynamicObject* pTaDynamicObject,
	const TaMFrame* frame);

TA_EXPORT const TaMFrame* TA_CALL TaDynamicObject_GetNextFrame(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaMFrame* TA_CALL TaDynamicObject_GetPreviousFrame(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaMFrame* TA_CALL TaDynamicObject_GetGraphicsFrame(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaVec3* TA_CALL TaDynamicObject_GetPosition(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetPosition(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Position);

TA_EXPORT const TaVec3* TA_CALL TaDynamicObject_GetCenterOfMass(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaVec3* TA_CALL TaDynamicObject_GetNextCenterOfMass(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaVec3* TA_CALL TaDynamicObject_GetCenterOffset(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetCenterOffset(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3CenterOffset);

TA_EXPORT void TA_CALL TaDynamicObject_SetFrameDirect(
	TaDynamicObject* pTaDynamicObject,
	const TaMFrame* frame);

TA_EXPORT float TA_CALL TaDynamicObject_GetMass(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT float TA_CALL TaDynamicObject_GetInverseMass(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetMass(
	TaDynamicObject* pTaDynamicObject,
	float fMass);

TA_EXPORT const TaMat33* TA_CALL TaDynamicObject_GetInertia(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetInertiaFromBox(
	TaDynamicObject* pTaDynamicObject,
	const TaAABB* aabb);

TA_EXPORT void TA_CALL TaDynamicObject_SetInertiaFromBox2(
	TaDynamicObject* pTaDynamicObject,
	float fX,
	float fY,
	float fZ);

TA_EXPORT const TaMat33* TA_CALL TaDynamicObject_GetInverseInertia(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaMat33* TA_CALL TaDynamicObject_GetWorldSpaceInertia(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaMat33* TA_CALL TaDynamicObject_GetWorldSpaceInverseInertia(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetFriction(
	TaDynamicObject* pTaDynamicObject,
	float fFriction);

TA_EXPORT float TA_CALL TaDynamicObject_GetFriction(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetRestitution(
	TaDynamicObject* pTaDynamicObject,
	float fRestitution);

TA_EXPORT float TA_CALL TaDynamicObject_GetRestitution(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetGravityMult(
	TaDynamicObject* pTaDynamicObject,
	float fGravityMult);

TA_EXPORT float TA_CALL TaDynamicObject_GetGravityMult(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetRotationDisabled(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_RotationDisabled(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetMovementDisabled(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_MovementDisabled(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetExtraStability(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_ExtraStability(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetRigidFrictionDisabled(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_RigidFrictionDisabled(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetCollisionDisabled(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_CollisionDisabled(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetUpdateDisabled(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_UpdateDisabled(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetGhost(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_Ghost(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetInfiniteMass(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_InfiniteMass(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetFindVelocityFromNextFrame(
	TaDynamicObject* pTaDynamicObject,
	TaBool bValue);

TA_EXPORT TaBool TA_CALL TaDynamicObject_GetFindVelocityFromNextFrame(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT TaBool TA_CALL TaDynamicObject_IsWorldObject(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetRestTimeMultiplier(
	TaDynamicObject* pTaDynamicObject,
	float fRestTimeMultiplier);

TA_EXPORT float TA_CALL TaDynamicObject_GetRestTimeMultiplier(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetID(
	TaDynamicObject* pTaDynamicObject,
	int nID);

TA_EXPORT int TA_CALL TaDynamicObject_GetID(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT TaPhysics* TA_CALL TaDynamicObject_GetPhysics(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT TaBool TA_CALL TaDynamicObject_IsInMovingList(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetToMoving(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetToResting(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaVec3* TA_CALL TaDynamicObject_GetLinearVelocity(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetLinearVelocity(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3LinearVelocity);

TA_EXPORT const TaVec3* TA_CALL TaDynamicObject_GetAngularVelocity(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetAngularVelocity(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3AngularVelocity);

TA_EXPORT void TA_CALL TaDynamicObject_SetVelocitiesToMoveToFrame(
	TaDynamicObject* pTaDynamicObject,
	const TaMFrame* mFrame,
	float fDt);

TA_EXPORT TaVec3 TA_CALL TaDynamicObject_GetVelocityAtWorldPosition(
	const TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Position);

TA_EXPORT void TA_CALL TaDynamicObject_ApplyImpulse(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3WorldImpulse,
	const TaVec3* v3WorldPosition);

TA_EXPORT void TA_CALL TaDynamicObject_ApplyLinearImpulse(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3WorldLinearImpulse);

TA_EXPORT void TA_CALL TaDynamicObject_ApplyAngularImpulse(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3WorldAngularImpulse);

TA_EXPORT void TA_CALL TaDynamicObject_AssertForceAndTorqueCleared(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_AccumulateGravity(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_AccumulateForceAndTorque(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3WorldForce,
	const TaVec3* v3WorldPosition);

TA_EXPORT void TA_CALL TaDynamicObject_AccumulateLinearForce(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3WorldForce);

TA_EXPORT void TA_CALL TaDynamicObject_ApplyForceAndTorqueToVelocities(
	TaDynamicObject* pTaDynamicObject,
	float fDt);

TA_EXPORT void TA_CALL TaDynamicObject_ClearForceAndTorque(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_Clear(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_UpdateWorldSpaceInertialTensor(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_Update(
	TaDynamicObject* pTaDynamicObject,
	float fDt);

TA_EXPORT void TA_CALL TaDynamicObject_UpdateGraphics(
	TaDynamicObject* pTaDynamicObject,
	float fDt,
	float fInterpolant);

TA_EXPORT void TA_CALL TaDynamicObject_Extrapolate(
	TaDynamicObject* pTaDynamicObject,
	const TaMFrame* frameA,
	const TaMFrame* frameB,
	const TaVec3* v3VelocityA,
	const TaVec3* v3VelocityB,
	float fDt,
	float fExtrapolation);

TA_EXPORT void TA_CALL TaDynamicObject_ApplyVelocityToNextFrame(
	TaDynamicObject* pTaDynamicObject,
	float fDt);

TA_EXPORT void TA_CALL TaDynamicObject_ApplyNextFrame(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_Render(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_CalculateWorldAABB(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaAABB* TA_CALL TaDynamicObject_GetWorldAABB(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT TaCollisionObjectCombo* TA_CALL TaDynamicObject_GetCollisionObjectCombo(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT TaCollisionObjectComplex* TA_CALL TaDynamicObject_GetCollisionObjectComplex(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetCollisionObject(
	TaDynamicObject* pTaDynamicObject,
	TaCollisionObjectCombo* pCollisionObjectCombo,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT void TA_CALL TaDynamicObject_SetCollisionObjectChanged(
	TaDynamicObject* pTaDynamicObject,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT void TA_CALL TaDynamicObject_ReinitCollisionAsABox(
	TaDynamicObject* pTaDynamicObject,
	const TaAABB* aabb,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT void TA_CALL TaDynamicObject_ReinitCollisionAsAnOrientedBox(
	TaDynamicObject* pTaDynamicObject,
	const TaAABB* aabb,
	const TaMFrame* mFrame,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT void TA_CALL TaDynamicObject_ReinitCollisionAsACapsule(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Start,
	const TaVec3* v3End,
	float fRadius,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT void TA_CALL TaDynamicObject_ReinitCollisionAsASphere(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Center,
	float fRadius,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT void TA_CALL TaDynamicObject_ReinitCollisionAsACylinder(
	TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Start,
	const TaVec3* v3End,
	float fRadius,
	int nFlags /* default = (REINIT_FLAG_UPDATE_MASS | REINIT_FLAG_UPDATE_INERTIA_TENSOR | REINIT_FLAG_UPDATE_CENTER_OFFSET) */);

TA_EXPORT TaBool TA_CALL TaDynamicObject_TestLineForCollision(
	const TaDynamicObject* pTaDynamicObject,
	const TaVec3* v3Start,
	const TaVec3* v3Normal,
	float fLength,
	TaCollision* collision);

TA_EXPORT int TA_CALL TaDynamicObject_GetNumLineCollisions(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT const TaLineIntersection* TA_CALL TaDynamicObject_GetLineCollision(
	const TaDynamicObject* pTaDynamicObject,
	int nIndex);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJoint(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject);

TA_EXPORT void TA_CALL TaDynamicObject_RemoveAllJoints(
	TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_RemoveJoint(
	TaDynamicObject* pTaDynamicObject,
	TaPhysicsJoint* joint);

TA_EXPORT void TA_CALL TaDynamicObject_RemoveJointsToObject(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pDynamicObject);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJoint2(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LocalPos,
	const TaVec3* v3LocalPosOnOtherObject,
	const TaMat33* m33DefaultRotationOfOtherObject,
	const TaEulerAngles* minAngles,
	const TaEulerAngles* maxAngles);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJointTypeHinge(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LocalPos,
	const TaVec3* v3LocalPosOnOtherObject,
	const TaVec3* v3LocalHingeAxis,
	const TaVec3* v3LocalHingeNormal,
	float fMinAngle,
	float fMaxAngle);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJointTypeSocket(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LocalPos,
	const TaVec3* v3LocalPosOnOtherObject,
	const TaVec3* v3LimitCenterNormal,
	const TaVec3* v3LimitCenterNormalOnOtherObject,
	float fMaxAngle);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJointTypeLimitedSocket(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LocalPos,
	const TaVec3* v3LocalPosOnOtherObject,
	const TaMat33* m33DefaultRotationOfOtherObject,
	float fMaxAngleY,
	float fMaxAngleXZ);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJointTypeSquareSocket(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LocalPos,
	const TaVec3* v3LocalPosOnOtherObject,
	const TaMat33* m33DefaultRotationOfOtherObject,
	float fMinX,
	float fMaxX,
	float fMinY,
	float fMaxY,
	float fMinZ,
	float fMaxZ);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddJointTypeSlider(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LocalPos,
	const TaVec3* v3StartPosOnOtherObject,
	const TaVec3* v3EndPosPosOnOtherObject);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddRotationConstraint(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaMat33* m33DefaultRotationOfOtherObject,
	const TaEulerAngles* minAngles,
	const TaEulerAngles* maxAngles);

TA_EXPORT TaPhysicsJoint* TA_CALL TaDynamicObject_AddVectorConstraint(
	TaDynamicObject* pTaDynamicObject,
	TaDynamicObject* pOtherObject,
	const TaVec3* v3LimitCenterNormal,
	const TaVec3* v3LimitCenterNormalOnOtherObject,
	float fMaxAngle);

TA_EXPORT TaBool TA_CALL TaDynamicObject_IsAllowedToCollideWith(
	const TaDynamicObject* pTaDynamicObject,
	const TaDynamicObject* otherObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetUserGroup(
	TaDynamicObject* pTaDynamicObject,
	int nUserGroupId);

TA_EXPORT int TA_CALL TaDynamicObject_GetUserGroup(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetUserGroupItemId(
	TaDynamicObject* pTaDynamicObject,
	int nUserGroupItemId);

TA_EXPORT int TA_CALL TaDynamicObject_GetUserGroupItemId(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_DisallowCollisionWithUserGroupItemId(
	TaDynamicObject* pTaDynamicObject,
	int nUserGroupItemId);

TA_EXPORT void TA_CALL TaDynamicObject_AllowCollisionWithUserGroupItemId(
	TaDynamicObject* pTaDynamicObject,
	int nUserGroupItemId);

TA_EXPORT void TA_CALL TaDynamicObject_SetCollisionUserData(
	TaDynamicObject* pTaDynamicObject,
	void* pData);

TA_EXPORT void* TA_CALL TaDynamicObject_GetCollisionUserData(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT void TA_CALL TaDynamicObject_SetUserData(
	TaDynamicObject* pTaDynamicObject,
	void* pData);

TA_EXPORT void* TA_CALL TaDynamicObject_GetUserData(
	const TaDynamicObject* pTaDynamicObject);

TA_EXPORT int TA_CALL TaDynamicObject_CreateUserGroup();

TA_EXPORT TaDynamicObject* TA_CALL TaDynamicObject_CreateNew();

TA_EXPORT void TA_CALL TaDynamicObject_Release(
	TaDynamicObject* pTaDynamicObject);

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus

#if defined(__cplusplus) && !defined(TA_C_IMPLEMENTATION)
#include "DynamicObject.hpp"
#endif // defined(__cplusplus) && !defined(TA_C_IMPLEMENTATION)

#endif // TA_DYNAMICOBJECTWRAPPER_H
