//---------------------------------------------------------------------------------
//
// Autogenerated from CreateDllWrapper.pl
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
// All Rights Reserved.
//
//---------------------------------------------------------------------------------

#ifndef TA_PHYSICS_WRAPPER_H
#define TA_PHYSICS_WRAPPER_H

#include "../Common/Types.h"

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

enum
{
	TA_PHYSICS_FLAG_DYNAMIC_OBJECTS =			0x1,
	TA_PHYSICS_FLAG_STATIC_OBJECTS	=			0x2,
	
	TA_PHYSICS_FLAG_ALL_OBJECTS = TA_PHYSICS_FLAG_DYNAMIC_OBJECTS | TA_PHYSICS_FLAG_STATIC_OBJECTS, //pl. pascal($1 + $2;)
	TA_PHYSICS_FLAG_ALL_NON_DYNAMIC_OBJECTS = TA_PHYSICS_FLAG_STATIC_OBJECTS, //pl. pascal($2;)
	
	TA_PHYSICS_FLAG_GHOST_OBJECTS =			0x8,
	TA_PHYSICS_FLAG_RENDER_COLLISIONS =		0x10,
	
	TA_PHYSICS_FLAG_SPACIAL_DIVISION_MASK =	0x20 + 0x40 + 0x80, 
	TA_PHYSICS_FLAG_XY_COLLISION_GRID =		0x20,
	TA_PHYSICS_FLAG_XZ_COLLISION_GRID =		0x40,
	TA_PHYSICS_FLAG_YZ_COLLISION_GRID =		0x60,
	TA_PHYSICS_FLAG_DYNAMIC_OCTREE =			0x80,
};

enum
{
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_DYNAMIC_OCTREE = 0,
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_XY_COLLISION_GRID = 1,
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_XZ_COLLISION_GRID = 2,
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_YZ_COLLISION_GRID = 3,
};

TA_EXPORT void TA_CALL TaPhysics_CreateInstance();

TA_EXPORT void TA_CALL TaPhysics_DestroyInstance();

TA_EXPORT TaPhysics* TA_CALL TaPhysics_GetInstance();

TA_EXPORT void TA_CALL TaPhysics_SetupSimulation(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_Update(
	TaPhysics* pTaPhysics,
	float fDt);

TA_EXPORT void TA_CALL TaPhysics_Render(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_AddStaticObject(
	TaPhysics* pTaPhysics,
	TaStaticObject* pStaticObject);

TA_EXPORT void TA_CALL TaPhysics_RemoveStaticObject(
	TaPhysics* pTaPhysics,
	TaStaticObject* pStaticObject);

TA_EXPORT int TA_CALL TaPhysics_AddSurfaceAttribute(
	TaPhysics* pTaPhysics,
	TaSurfaceAttribute* pSurfaceAttribute);

TA_EXPORT int TA_CALL TaPhysics_AddSurfaceAttribute2(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_RemoveSurfaceAttribute(
	TaPhysics* pTaPhysics,
	int nIndex);

TA_EXPORT TaSurfaceAttribute* TA_CALL TaPhysics_GetSurfaceAttribute(
	TaPhysics* pTaPhysics,
	int nIndex);

TA_EXPORT int TA_CALL TaPhysics_GetNumSurfaceAttributes(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetDefaultSurfaceAttribute(
	TaPhysics* pTaPhysics,
	TaSurfaceAttribute* pSurfaceAttribute);

TA_EXPORT const TaSurfaceAttribute* TA_CALL TaPhysics_GetDefaultSurfaceAttribute(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_AddDynamicObject(
	TaPhysics* pTaPhysics,
	TaDynamicObject* pDynamicObject,
	TaBool bInitiallyMoving /* default = true */);

TA_EXPORT void TA_CALL TaPhysics_RemoveDynamicObject(
	TaPhysics* pTaPhysics,
	TaDynamicObject* pDynamicObject);

TA_EXPORT void TA_CALL TaPhysics_SetDynamicObjectIsMoving(
	TaPhysics* pTaPhysics,
	TaDynamicObject* pDynamicObject);

TA_EXPORT void TA_CALL TaPhysics_SetDynamicObjectAtRest(
	TaPhysics* pTaPhysics,
	TaDynamicObject* pDynamicObject);

TA_EXPORT void TA_CALL TaPhysics_TestLineForCollision(
	TaPhysics* pTaPhysics,
	const TaVec3* v3Start,
	const TaVec3* v3Normal,
	float fLength,
	TaCollision* collision,
	ta_u32 nFlags);

TA_EXPORT void TA_CALL TaPhysics_TestLineForCollision2(
	TaPhysics* pTaPhysics,
	const TaVec3* v3Start,
	const TaVec3* v3End,
	TaCollision* collision,
	ta_u32 nFlags /* default = FLAG_ALL_OBJECTS */);

TA_EXPORT const TaVec3* TA_CALL TaPhysics_GetGravity(
	const TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetGravity(
	TaPhysics* pTaPhysics,
	const TaVec3* v3Gravity);

TA_EXPORT void TA_CALL TaPhysics_SetRenderCollisionsEnabled(
	TaPhysics* pTaPhysics,
	TaBool bValue);

TA_EXPORT void TA_CALL TaPhysics_SetWorldDimensions(
	TaPhysics* pTaPhysics,
	const TaAABB* worldAABB);

TA_EXPORT const TaAABB* TA_CALL TaPhysics_GetWorldDimensions(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetMaxNumCollisions(
	TaPhysics* pTaPhysics,
	int nMaxNumCollisions);

TA_EXPORT int TA_CALL TaPhysics_GetMaxNumCollisions(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetMaxNumMovingObjects(
	TaPhysics* pTaPhysics,
	int nMaxNumMovingObjects);

TA_EXPORT int TA_CALL TaPhysics_GetMaxNumMovingObjects(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetSlowSolverMaxNumCollisions(
	TaPhysics* pTaPhysics,
	int nSlowSolverMaxNumCollisions);

TA_EXPORT int TA_CALL TaPhysics_GetSlowSolverMaxNumCollisions(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetSlowSolverMaxNumObjects(
	TaPhysics* pTaPhysics,
	int nSlowSolverMaxNumObjects);

TA_EXPORT int TA_CALL TaPhysics_GetSlowSolverMaxNumObjects(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetMaxNumObjectPairs(
	TaPhysics* pTaPhysics,
	int nMaxNumObjectPairs);

TA_EXPORT int TA_CALL TaPhysics_GetMaxNumObjectPairs(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetSpacialDivisionType(
	TaPhysics* pTaPhysics,
	int eSpacialDivisionType);

TA_EXPORT int TA_CALL TaPhysics_GetSpacialDivisionType(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetSpacialDivisionMinSize(
	TaPhysics* pTaPhysics,
	float fSpacialDivisionMinSize);

TA_EXPORT float TA_CALL TaPhysics_GetSpacialDivisionMinSize(
	TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetSpacialDivisionMaxMemory(
	TaPhysics* pTaPhysics,
	int nSpacialDivisionMaxMemory);

TA_EXPORT int TA_CALL TaPhysics_GetSpacialDivisionMaxMemory(
	TaPhysics* pTaPhysics);

TA_EXPORT TaDynamicVsDynamicCollisionTestCallBack TA_CALL TaPhysics_GetDynamicVsDynamicCollisionTestCallBack(
	const TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetDynamicVsDynamicCollisionTestCallBack(
	TaPhysics* pTaPhysics,
	TaDynamicVsDynamicCollisionTestCallBack pFnDynamicVsDynamicCollisionTest);

TA_EXPORT TaPreProcessCollisionCallBack TA_CALL TaPhysics_GetPreProcessCollisionCallBack(
	const TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetPreProcessCollisionCallBack(
	TaPhysics* pTaPhysics,
	TaPreProcessCollisionCallBack pFnPreProcessCollision);

TA_EXPORT TaPostProcessCollisionCallBack TA_CALL TaPhysics_GetPostProcessCollisionCallBack(
	const TaPhysics* pTaPhysics);

TA_EXPORT void TA_CALL TaPhysics_SetPostProcessCollisionCallBack(
	TaPhysics* pTaPhysics,
	TaPostProcessCollisionCallBack pFnPostProcessCollision);

TA_EXPORT void TA_CALL TaPhysics_CreateInstance2(
	const TaAABB* worldAABB,
	const TaVec3* v3Gravity, /* default = Vec3(0.0f, -9.81f, 0.0f) */
	ta_u32 nFlags, /* default = FLAG_XZ_COLLISION_GRID */
	float fMinSpacialDivision, /* default = 10.0f */
	int nSpacialDivisionMemory /* default = 0x40000 */);

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus

#if defined(__cplusplus) && !defined(TA_C_IMPLEMENTATION)
#include "Physics.hpp"
#endif // defined(__cplusplus) && !defined(TA_C_IMPLEMENTATION)

#endif // TA_PHYSICSWRAPPER_H
